#define TSR_ID 12345    /* TSR id */

#define FAR_WORD(seg, ofs)         (* (unsigned far *) MK_FP(seg, ofs) )
#define FAR_CHAR(seg, ofs)         (* (char far *) MK_FP(seg, ofs) )
#define IS_ARENA_HEADER(seg)       ( FAR_CHAR(seg, 0) == 'M' )
#define IS_PSP_ARENA_HEADER(seg)   ( FAR_WORD(seg, 1) == ((seg)+1) )
#define IS_FIRST_ARENA_HEADER(seg) ( IS_ARENA_HEADER( seg )  &&  \
                                     IS_PSP_ARENA_HEADER( seg ) )
#define IS_LAST_ARENA_HEADER(seg)  ( FAR_CHAR(seg, 0) == 'Z')
#define ARENA_SIZE(seg)            ( FAR_WORD(seg, 3) )
#define NEXT_ARENA_HEADER(seg)     ( ARENA_SIZE(seg) + (seg) + 1 )


/* Program vars/options structure */
struct
{
        unsigned int psp;                       /* Program segment - used for unloading */
        unsigned int loaded_flag;               /* TSR unique ID no */

        unsigned int mode;                      /* VESA mode last called */
        unsigned int scanwidth;                 /* Scanline in pixels */
        unsigned int scanbyte;                  /* Scanline in bytes */
        unsigned int scantotal;                 /* Max number of scanlines available */
//.s
        unsigned int bitsperpixel;
//        unsigned int temp;
//        WORD         bx;
//        WORD         cx;
//        WORD         dx;
//        DWORD        dwtemp;
        char use_pm_interface;
        char use_dbcs;
//.e
        unsigned long membytes;                 /* Video memory in bytes */

        char linear;                            /* Mode is linear */
        char dbl;                               /* Double width mode  (1 = on, 0 = off) */
        unsigned char current_ticks;            /* Current tick before reprogramming VGA */

/* Options that change the effect of the TSR */

        char unload;                            /* Unload TSR, if loaded */
        char enabled;                           /* Enable = 1, Disable =0 */
        char vidmem;                            /* Video memory in megs */
        unsigned char max_ticks;                /* Max ticks, when reached re-program the VGA again */

        int center_x;
        int center_y;
        int h_sync_delay;
        int h_disp_delay;
} PROGRAM;


char YesNo[3][4]={
        {"off"},
        {"on"},
};

char *usage =
        "Usage:\TSR\t[options]\n"
        "Options:-\n"
        "\t-h - cmdline options\n"
        "\t-u - unload and restore\n"
        "\t-e - enable/disable TSR\n"
        "\t-m<1-48> - set default video memory\n"
        "\t-w<1-255> - delay before trying to reprogram ModeX modes\n"
        "\t-w0 - ModeX reprogram disable\n"

        "\t-x<-16/16> - screen horizontal position\n"
        "\t-y<-8/8> - screen vertical position\n"
        "\t-1<1-3> - horizontal sync delay\n"
        "\t-2<1-3> - horizontal disp delay\n"

#ifdef SUPPORT_DBCS
        "\t-p - enable/disable own protected mode interface\n"
        "\t-d - enable/disable DBCS 640x480 text mode\n";
#else
        "\t-p - enable/disable own protected mode interface\n";
#endif

/* Function Prototypes */
void    interrupt int_10(void);
void    interrupt int_8(void);
void    interrupt (*old_int10)(void);
void    interrupt (*old_int8)(void);
void    tsr();
void    freetsr(unsigned int);


#define     ofsAX   0x10
#define     ofsBX   0x0E
#define     ofsCX   0x0C
#define     ofsDX   0x0A
#define     ofsES   0x08
#define     ofsDS   0x06
#define     ofsSI   0x04
#define     ofsDI   0x02
#define     ofsBP   0x00
